<?php

namespace App\Filament\Resources\Panel;

use Filament\Forms;
use Filament\Tables;
use App\Models\Land;
use Livewire\Component;
use Filament\Forms\Form;
use Filament\Tables\Table;
use Filament\Resources\Resource;
use Filament\Forms\Components\Grid;
use Filament\Forms\Components\Section;
use Filament\Tables\Columns\TextColumn;
use Filament\Forms\Components\TextInput;
use Illuminate\Database\Eloquent\Builder;
use App\Filament\Resources\Panel\LandResource\Pages;
use App\Filament\Resources\Panel\LandResource\RelationManagers;

class LandResource extends Resource
{
    protected static ?string $model = Land::class;

    protected static ?string $navigationIcon = 'heroicon-o-rectangle-stack';

    protected static ?int $navigationSort = 4;

    protected static ?string $navigationGroup = 'البيانات الأساسيه';

    public static function getModelLabel(): string
    {
        return __('crud.lands.itemTitle');
    }

    public static function getPluralModelLabel(): string
    {
        return __('crud.lands.collectionTitle');
    }

    public static function getNavigationLabel(): string
    {
        return __('crud.lands.collectionTitle');
    }

    public static function form(Form $form): Form
    {
        return $form->schema([
            Section::make()->schema([
                Grid::make(['default' => 1])->schema([
                    TextInput::make('name')
                        ->required()
                        ->string()
                        ->unique('lands', 'name', ignoreRecord: true)
                        ->autofocus(),

                    TextInput::make('address')
                        ->required()
                        ->string(),

                    TextInput::make('phone')
                        ->nullable()
                        ->string(),
                ]),
            ]),
        ]);
    }

    public static function table(Table $table): Table
    {
        return $table
            ->poll('60s')
            ->columns([
                TextColumn::make('name')->badge()
                ->searchable()
                ->sortable()
                ->toggleable(),

                TextColumn::make('address')->badge()
                ->searchable()
                ->sortable()
                ->toggleable(),

                TextColumn::make('phone')->badge()
                ->searchable()
                ->sortable()
                ->toggleable(),
            ])
            ->filters([])
            ->actions([
                Tables\Actions\EditAction::make(),
                Tables\Actions\ViewAction::make(),
            ])
            ->bulkActions([
                Tables\Actions\BulkActionGroup::make([
                    Tables\Actions\DeleteBulkAction::make(),
                ]),
            ])
            ->defaultSort('id', 'desc');
    }

    public static function getRelations(): array
    {
        return [];
    }

    public static function getPages(): array
    {
        return [
            'index' => Pages\ListLands::route('/'),
            'create' => Pages\CreateLand::route('/create'),
            'view' => Pages\ViewLand::route('/{record}'),
            'edit' => Pages\EditLand::route('/{record}/edit'),
        ];
    }
}
